/// <reference types="react" />
import { PointsProps } from "@react-three/fiber";
import * as THREE from "three";
type uniforms = {
    [name: string]: THREE.CubeTexture | THREE.Texture | Int32Array | Float32Array | THREE.Matrix4 | THREE.Matrix3 | THREE.Quaternion | THREE.Vector4 | THREE.Vector3 | THREE.Vector2 | THREE.Color | number | boolean | Array<any> | null;
};
type attribute = {
    name: string;
    array: THREE.TypedArray;
    itemSize: number;
};
type properties = PointsProps & {
    modelsArray: THREE.Mesh[];
    pointsCount?: number;
    pointsVertFunctions?: string;
    pointsFragFunctions?: string;
    modelA?: number | null;
    modelB?: number | null;
    progress?: number;
    uniforms?: uniforms;
    baseColor?: string;
    pointSize?: number;
    alpha?: number;
    attributes?: attribute[];
    blending?: THREE.Blending;
};
type R3FPointsFXRefType = {
    getSimulationMesh: () => THREE.Mesh;
    getPointsMesh: () => THREE.Points;
    updateProgress: (progress: number) => void;
    updateTime: (time: number) => void;
    setModelA: (index: number) => void;
    setModelB: (index: number) => void;
};
declare const R3FPointsFX: import("react").ForwardRefExoticComponent<Omit<properties, "ref"> & import("react").RefAttributes<R3FPointsFXRefType>>;
export type { R3FPointsFXRefType };
export { R3FPointsFX };
