import { jsxs as c, Fragment as B, jsx as s } from "react/jsx-runtime";
import { useFrame as G, createPortal as H } from "@react-three/fiber";
import { forwardRef as I, useMemo as f, useRef as b, useEffect as W, useImperativeHandle as X } from "react";
import { useFBO as $ } from "@react-three/drei";
import * as a from "three";
import k from "./sampler/surfaceSampler.js";
import { convertToNativeUniforms as q } from "./helpers/convert.js";
import D from "./shaders/FBOMeshvert.js";
import J from "./shaders/FBOMeshfrag.js";
import K from "./shaders/points_vert_header.js";
import L from "./shaders/points_vert_defaults.js";
import Q from "./shaders/points_vert_main.js";
import V from "./shaders/points_frag_header.js";
import Y from "./shaders/points_frag_defaults.js";
import Z from "./shaders/points_frag_main.js";
const vr = I(
  ({
    modelsArray: h,
    pointsCount: i = 128,
    pointsVertFunctions: g = L,
    pointsFragFunctions: M = Y,
    modelA: u = null,
    modelB: l = null,
    progress: C = 0,
    uniforms: S = {},
    baseColor: v = "#FFF",
    pointSize: p = 1,
    alpha: d = 1,
    attributes: A = [],
    blending: R = a.AdditiveBlending,
    ...z
  }, O) => {
    const o = f(() => {
      const r = [];
      for (let e = 0; e < h.length; ++e)
        r.push(k(i, h[e]));
      return r;
    }, [h, i]), n = b(null), t = b(null), x = f(() => K + g + Q, [g]), E = f(() => V + M + Z, [M]), N = f(() => ({
      uTransitionProgress: { value: 0 },
      uTime: { value: 0 },
      positionsA: {
        value: u !== null ? o[u] : null
      },
      positionsB: {
        value: l !== null ? o[l] : null
      }
    }), [u, l]), U = f(() => ({
      uPositions: { value: null },
      uColor: { value: new a.Color(v) },
      uTime: { value: 0 },
      uTransitionProgress: { value: 0 },
      uModel1: { value: u },
      uModel2: { value: l },
      uPointSize: { value: p },
      uAlpha1: { value: d },
      ...q(S)
    }), []);
    W(() => {
      t.current && t.current.material instanceof a.ShaderMaterial && (t.current.material.uniforms.uColor.value = new a.Color(
        v
      ), t.current.material.uniforms.uModel1.value = u, t.current.material.uniforms.uModel2.value = l, t.current.material.uniforms.uPointSize.value = p, t.current.material.uniforms.uAlpha1.value = d);
    }, [v, u, l, p, d, S]);
    const F = new a.Scene(), j = new a.OrthographicCamera(
      -1,
      1,
      1,
      -1,
      1 / Math.pow(2, 53),
      1
    ), T = new Float32Array([
      -1,
      -1,
      0,
      1,
      -1,
      0,
      1,
      1,
      0,
      -1,
      -1,
      0,
      1,
      1,
      0,
      -1,
      1,
      0
    ]), P = new Float32Array([0, 1, 1, 1, 1, 0, 0, 1, 1, 0, 0, 0]), y = $({
      minFilter: a.NearestFilter,
      magFilter: a.NearestFilter,
      type: a.FloatType
    }), _ = f(() => {
      const r = i * i, e = new Float32Array(r * 3);
      for (let m = 0; m < r; m++) {
        let w = m * 3;
        e[w + 0] = m % i / i, e[w + 1] = m / i / i;
      }
      return e;
    }, [i]);
    return X(
      O,
      () => ({
        getSimulationMesh: () => n.current,
        getPointsMesh: () => t.current,
        updateProgress: (r) => {
          t.current && t.current.material instanceof a.ShaderMaterial && (t.current.material.uniforms.uTransitionProgress.value = r), n.current && n.current.material instanceof a.ShaderMaterial && (n.current.material.uniforms.uTransitionProgress.value = r);
        },
        updateTime: (r) => {
          n.current && n.current.material instanceof a.ShaderMaterial && (n.current.material.uniforms.uTime.value = r), t.current && t.current.material instanceof a.ShaderMaterial && (t.current.material.uniforms.uTime.value = r);
        },
        setModelA: (r) => {
          if (n.current && t.current && n.current.material instanceof a.ShaderMaterial && t.current.material instanceof a.ShaderMaterial) {
            let e = null;
            r >= 0 && r < o.length && (e = r), n.current.material.uniforms.positionsA.value = e !== null ? o[e] : null, t.current.material.uniforms.uModel1.value = e !== null ? e : null;
          }
        },
        setModelB: (r) => {
          if (n.current && t.current && n.current.material instanceof a.ShaderMaterial && t.current.material instanceof a.ShaderMaterial) {
            let e = null;
            r >= 0 && r < o.length && (e = r), n.current.material.uniforms.positionsB.value = e !== null ? o[e] : null, t.current.material.uniforms.uModel2.value = e !== null ? e : null;
          }
        }
      }),
      []
    ), G((r) => {
      const { gl: e } = r;
      e.setRenderTarget(y), e.clear(), e.render(F, j), e.setRenderTarget(null), t.current && t.current.material instanceof a.ShaderMaterial && (t.current.material.uniforms.uPositions.value = y.texture);
    }), /* @__PURE__ */ c(B, { children: [
      H(
        /* @__PURE__ */ c("mesh", { ref: n, children: [
          /* @__PURE__ */ c("bufferGeometry", { children: [
            /* @__PURE__ */ s(
              "bufferAttribute",
              {
                attach: "attributes-position",
                count: T.length / 3,
                array: T,
                itemSize: 3
              }
            ),
            /* @__PURE__ */ s(
              "bufferAttribute",
              {
                attach: "attributes-uv",
                count: P.length / 2,
                array: P,
                itemSize: 2
              }
            )
          ] }),
          /* @__PURE__ */ s(
            "shaderMaterial",
            {
              uniforms: N,
              vertexShader: D,
              fragmentShader: J
            }
          )
        ] }),
        F
      ),
      /* @__PURE__ */ c("points", { ref: t, ...z, children: [
        /* @__PURE__ */ c("bufferGeometry", { children: [
          /* @__PURE__ */ s(
            "bufferAttribute",
            {
              attach: "attributes-position",
              count: _.length / 3,
              array: _,
              itemSize: 3
            }
          ),
          A.map((r, e) => /* @__PURE__ */ s(
            "bufferAttribute",
            {
              attach: `attributes-${r.name}`,
              count: r.array.length / r.itemSize,
              array: r.array,
              itemSize: r.itemSize
            },
            e
          ))
        ] }),
        /* @__PURE__ */ s(
          "shaderMaterial",
          {
            uniforms: U,
            vertexShader: x,
            fragmentShader: E,
            blending: R,
            depthWrite: !1
          }
        )
      ] })
    ] });
  }
);
export {
  vr as R3FPointsFX
};
