import * as h from "three";
import { Triangle as S, Vector3 as y, Vector2 as m } from "three";
const i = new S(), A = new y(), g = new m(), p = new m(), w = new m();
class B {
  constructor(t) {
    this.geometry = t.geometry, this.randomFunction = Math.random, this.indexAttribute = this.geometry.index, this.positionAttribute = this.geometry.getAttribute("position"), this.normalAttribute = this.geometry.getAttribute("normal"), this.colorAttribute = this.geometry.getAttribute("color"), this.uvAttribute = this.geometry.getAttribute("uv"), this.weightAttribute = null, this.distribution = null;
  }
  setWeightAttribute(t) {
    return this.weightAttribute = t ? this.geometry.getAttribute(t) : null, this;
  }
  build() {
    const t = this.indexAttribute, s = this.positionAttribute, o = this.weightAttribute, n = t ? t.count / 3 : s.count / 3, a = new Float32Array(n);
    for (let r = 0; r < n; r++) {
      let l = 1, c = 3 * r, d = 3 * r + 1, f = 3 * r + 2;
      t && (c = t.getX(c), d = t.getX(d), f = t.getX(f)), o && (l = o.getX(c) + o.getX(d) + o.getX(f)), i.a.fromBufferAttribute(s, c), i.b.fromBufferAttribute(s, d), i.c.fromBufferAttribute(s, f), l *= i.getArea(), a[r] = l;
    }
    const e = new Float32Array(n);
    let u = 0;
    for (let r = 0; r < n; r++)
      u += a[r], e[r] = u;
    return this.distribution = e, this;
  }
  setRandomGenerator(t) {
    return this.randomFunction = t, this;
  }
  sample(t, s, o, n) {
    const a = this.sampleFaceIndex();
    return this.sampleFace(a, t, s, o, n);
  }
  sampleFaceIndex() {
    const t = this.distribution[this.distribution.length - 1];
    return this.binarySearch(this.randomFunction() * t);
  }
  binarySearch(t) {
    const s = this.distribution;
    let o = 0, n = s.length - 1, a = -1;
    for (; o <= n; ) {
      const e = Math.ceil((o + n) / 2);
      if (e === 0 || s[e - 1] <= t && s[e] > t) {
        a = e;
        break;
      } else
        t < s[e] ? n = e - 1 : o = e + 1;
    }
    return a;
  }
  sampleFace(t, s, o, n, a) {
    let e = this.randomFunction(), u = this.randomFunction();
    e + u > 1 && (e = 1 - e, u = 1 - u);
    const r = this.indexAttribute;
    let l = t * 3, c = t * 3 + 1, d = t * 3 + 2;
    return r && (l = r.getX(l), c = r.getX(c), d = r.getX(d)), i.a.fromBufferAttribute(this.positionAttribute, l), i.b.fromBufferAttribute(this.positionAttribute, c), i.c.fromBufferAttribute(this.positionAttribute, d), s.set(0, 0, 0).addScaledVector(i.a, e).addScaledVector(i.b, u).addScaledVector(i.c, 1 - (e + u)), o !== void 0 && (this.normalAttribute !== void 0 ? (i.a.fromBufferAttribute(this.normalAttribute, l), i.b.fromBufferAttribute(this.normalAttribute, c), i.c.fromBufferAttribute(this.normalAttribute, d), o.set(0, 0, 0).addScaledVector(i.a, e).addScaledVector(i.b, u).addScaledVector(i.c, 1 - (e + u)).normalize()) : i.getNormal(o)), n !== void 0 && this.colorAttribute !== void 0 && (i.a.fromBufferAttribute(this.colorAttribute, l), i.b.fromBufferAttribute(this.colorAttribute, c), i.c.fromBufferAttribute(this.colorAttribute, d), A.set(0, 0, 0).addScaledVector(i.a, e).addScaledVector(i.b, u).addScaledVector(i.c, 1 - (e + u)), n.r = A.x, n.g = A.y, n.b = A.z), a !== void 0 && this.uvAttribute !== void 0 && (g.fromBufferAttribute(this.uvAttribute, l), p.fromBufferAttribute(this.uvAttribute, c), w.fromBufferAttribute(this.uvAttribute, d), a.set(0, 0).addScaledVector(g, e).addScaledVector(p, u).addScaledVector(w, 1 - (e + u))), this;
  }
}
const V = (b, t) => {
  const s = b * b * 4, o = new Float32Array(s), n = new B(t).build();
  for (let e = 0; e < s; e++) {
    const u = e * 4, r = new h.Vector3();
    n.sample(r), o[u] = r.x, o[u + 1] = r.y, o[u + 2] = r.z, o[u + 3] = 1;
  }
  const a = new h.DataTexture(
    o,
    b,
    b,
    h.RGBAFormat,
    h.FloatType
  );
  return a.needsUpdate = !0, a;
};
export {
  V as default
};
